<?php
  /**************************************************************************\
  * phpGroupWare app (NNTP)                                               *
  * http://www.phpgroupware.org                                              *
  * Written by Mark Peters <mpeters@satx.rr.com>                             *
  * --------------------------------------------                             *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/

  /* $Id: functions.inc.php,v 1.16 2001/01/02 02:29:56 skeeter Exp $ */
  $d1 = strtolower(substr($phpgw_info["server"]["app_inc"],0,3));
  if($d1 == "htt" || $d1 == "ftp" ) {
    echo "Failed attempt to break in via an old Security Hole!<br>\n";
    $phpgw->common->phpgw_exit();
  } unset($d1);

$tmp_app_inc = $phpgw_info["server"]["app_inc"];
$phpgw_info["server"]["app_inc"] = $phpgw_info["server"]["server_root"]."/nntp/inc";
include($phpgw_info["server"]["app_inc"]."/mail.inc.php");
$phpgw_info["server"]["app_inc"] = $tmp_app_inc;

class NNTP extends MAIL {

var $db;

var $con;
var $folder;
var $groupname;
var $messagecount;
var $lowmsg;
var $highmsg;
var $active;
var $lastread;
var $msgnum;
var $display;

  function NNTP($folder="",$msgnum="") {
    global $phpgw;
    global $phpgw_info;

    if (!$this->init("nntp")) return 0;
    $this->db = $phpgw->db;

    if (!$this->mail_open($phpgw_info["server"]["nntp_server"],
			  $phpgw_info["server"]["nntp_port"],
			  $phpgw_info["server"]["nntp_login_username"],
			  $phpgw_info["server"]["nntp_login_password"])) return 0;

    if ($folder<>"" && $msgnum<>"") {
      if (!$this->read_table($folder,$msgnum)) return 0;

      $this->mail_header($this->msgnum);
      $this->mail_fetchstructure($this->msgnum);
      return 1;
    }
  }

  function update_lastread_info() {
    $this->db->query("UPDATE newsgroups SET lastread = ".time()." WHERE con=".$this->con);
  }

  function save_to_db($groupdb) {
    for($i=0;$i<count($groupdb["name"]);$i++) {
      $this->db->query("SELECT con FROM newsgroups WHERE name='"
		     . addslashes($groupdb["name"][$i])."'");
      if ($this->db->num_rows() > 0) {
	$this->db->next_record();
	$con = $this->db->f("con");
	$this->db->query("update newsgroups "
		       . "set messagecount=".$groupdb["count"][$i]
		       . ",lastmessage=".(int)$groupdb["last"][$i].", "
		       . "lastread=".time()." "
		       . "where con=$con");
      } else {
	$this->db->query("insert into newsgroups "
		       . "(name,messagecount,lastmessage,lastread) "
		       . "values('".addslashes($groupdb["name"][$i])."',"
		       . (int)$groupdb["count"][$i].","
		       . (int)$groupdb["last"][$i].",".time().")");
      }
    }
  }

  function load_table() {
    $retval = Array();
    $retval["name"] = Array();
    $retval["count"] = Array();
    $retval["last"] = Array();

    if (!$this->msg2socket("LIST","^215",&$response)) return 0;
   
    /* Default is: GROUP HIGH LOW FLAGS */
    while ($line = $this->read_port()) {
      $line = chop($line);
      if ($line == ".") break;
      if (!ereg("^control",$line) && !ereg("^junk",$line) && !ereg("^to ",$line)) {
	if (!$template || ereg($template, $line)) {
	  $fields = explode(" ", $line);
	  $count = ($fields[1] >= $fields[2] ? (int)$fields[1] - (int)$fields[2] + 1 : 0);
	  $retval["name"][] = $fields[0];
	  $retval["count"][] = $count;
	  $retval["last"][] = $fields[1];
	}
      }
    }
    $this->save_to_db($retval);
    return $retval;
  }

  function noexist() {
    $this->con		= 0;
    $this->groupname	= "";
    $this->mailbox	= "";
    $this->messagecount	= 0;
    $this->lowmsg	= 0;
    $this->highmsg	= 0;
    $this->active	= "N";
    $this->lastread	= 0;
    $this->msgnum	= 0;
  }

  function read_table($newsgroup,$msgnum=0) {
    global $phpgw, $phpgw_info;

    $this->db->query("SELECT * FROM newsgroups WHERE con=$newsgroup");
    if ($this->db->num_rows() > 0) {
      $this->db->next_record();
      $this->con          = $this->db->f(0);
      $this->folder	  = $this->db->f(1);
      $this->mailbox	  = $this->db->f(1);
      $this->messagecount = $this->db->f(2);
      $this->lowmsg	  = $this->mail_first_msg();
      $this->highmsg	  = $this->mail_last_msg();
      $this->active	  = $this->db->f(4);
      $this->lastread	  = $this->db->f(5);
      $this->msgnum	  = $msgnum;
      if ($this->active == "N") {
        $phpgw->common->preferences_delete("byappvar",$phpgw_info["user"]["account_id"],"nntp|".$newsgroup);
	return $this->set_error("ERROR","Automatic Disabling","The newsgroup ".$this->groupname." is not activated by the Administrator.");
      } elseif ($this->msgnum <> 0) {
	if (($this->msgnum < $this->lowmsg) || ($this->msgnum > $this->highmsg)) {
	  return $this->set_error("ERROR","Message does not exist",$this->mailbox.":".$this->msgnum." does not exist.");
	} else
	  return 1;
      } else {
	return 1;
      }
    } else {
      $this->noexist();
      $this->set_error("ERROR","Not valid","The news folder $newsgroup is not available.");
      return 0;
    }
  }

  function xhdr($field,$first,$last) {

    if (!$this->msg2socket("XHDR $field $first-$last","^221",&$response)) return 0;

    $retval = Array();
    while ($line = $this->read_port()) {
      $line = chop($line);
      if ($line == ".") break;
      $breakpos = strpos($line," ");
      $retval[substr($line,0,$breakpos)] = substr($line,$breakpos+1,strlen($line)-$breakpos);
    }
    return $retval;
  }

  function get_objects($field,$length) {
    $newarray = Array();
    $retval = $this->xhdr($field,$this->highmsg - $this->display,$this->highmsg);
    if (!$retval) return 0;
    while (list($nr,$fieldval) = each($retval)) {
      $fieldval = $this->decode->phpGW_quoted_printable_decode($fieldval);
      if ($length && (strlen($fieldval) > $length)) {
	$fieldval = substr($fieldval, 0, $length)."...";
      }
      $newarray[$nr] = $fieldval;
    }
    return $newarray;
  }

  function get_subjects() {
    $this->update_lastread_info();
    return $this->get_objects("Subject",35);
  }

  function get_list($field,$msgnum,$totaltodisplay) {
    $newarray = Array();
    $fields = array(0 => "From",1 => "Subject",2 => "Date");
    $i=0;
    while($i < $totaltodisplay) {
      if ($this->mail_fetch_overview($msgnum)) {
	$newarray[$i]["Msgnum"] = $msgnum;
	for($j=0;$j<2;$j++)
	  $newarray[$i][$fields[$j]] = $this->decode->phpGW_quoted_printable_decode(
						$this->header[$fields[$j]]
					    );
	$newarray[$i]["Date"] = $this->convert_date($this->header["Date"]);

	$i++;
      }
      $msgnum++;
    }
    return $newarray;
  }

  function get_next_article_number($msgnum) {
    $retval = array();
    if (!$this->msg2socket("STAT $msgnum","^223",&$response)) return 0;
    if (!$this->msg2socket("NEXT","^223",&$response)) return 0;
//    echo "Next_Msg = $response<br>\n";
    $retval = explode(" ",$response);
    return $retval[1];    
  }

  function get_prev_article_number($msgnum) {
    $retval = array();
    if (!$this->msg2socket("STAT $msgnum","^223",&$response)) return 0;
    if (!$this->msg2socket("LAST","^223",&$response)) return 0;
//    echo "Prev_Msg = $response<br>\n";
    $retval = explode(" ",$response);
    return $retval[1];    
  }

  function get_to() {
    global $phpgw, $phpgw_info;

    for($i=0;$i<count($this->msg->to);$i++) {
      $to = (!$this->msg->to[$i] ? $this->msg->to : $this->msg->to[$i]);
      $this->db->query("SELECT con FROM newsgroups WHERE name='" 
		     .$to->personal."' and active='Y'");
      if ($this->db->num_rows() > 0) {
	$this->db->next_record();
	$con = $this->db->f("con");
        $str[$i] = send_to($to,$con);
	if ($phpgw_info["user"]["preferences"]["nntp"]["$con"]) {
	  $str[$i] .= monitor(1,$con);
	} else {
	  $str[$i] .= monitor(0,0);
	}
      } else {
	$str[$i] = "<tr><td align=\"left\">"
		 . $to->adl . monitor(0,0);
      }
    }
    return implode("",$str);
  }
}
?>
