<?php
  /**************************************************************************\
  * phpGroupWare application (NNTP)                                          *
  * http://www.phpgroupware.org                                              *
  * Written by Mark Peters <mpeters@satx.rr.com>                             *
  * --------------------------------------------                             *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/

  /* $Id: index.php,v 1.28 2001/01/06 04:07:23 skeeter Exp $ */

  $phpgw_info["flags"] = array("noheader" => True, "nonavbar" => True);

  $phpgw_info["flags"]["currentapp"] = "nntp";
  include("../header.inc.php");

  while($pref = @each($phpgw_info["user"]["preferences"]["nntp"])) {
    $news[]=$pref[0];
  }

  if(!count($news)) {
    header("Location: ".$phpgw->link("preferences.php"));
  } else {
    $phpgw->common->phpgw_header();
    echo parse_navbar();
  }

  function close_routine() {
    global $nntp;
    $nntp->close_port();
  }

  @set_time_limit(0);
  $nntp = new NNTP;
  $nntp->display = $phpgw_info["user"]["preferences"]["common"]["maxmatchs"];
  if ($nntp->errorset) {
    echo $nntp->error["msg"].":".$nntp->error["desc"]."<br>\n";
    $phpgw->common->phpgw_exit();
  }

  register_shutdown_function("close_routine");

  $phpgw->template->set_file(array( "index_header"			=> "index.tpl",
		      "index_table_list_header"		=> "index_list_h.tpl",
		      "list"				=> "index_list_d.tpl",
		      "index_table_change_group"	=> "index_list_c.tpl",
		      "index_table_list_footer"		=> "index_list_f.tpl",
		      "index_footer"			=> "index.tpl" ));

  $phpgw->template->set_block("index_header","index_table_list_header","list",
		"index_table_change_group","index_table_list_footer",
		"index_footer","output");

  $phpgw->template->parse("out","index_header");

  $phpgw->template->set_var("th_bg",$phpgw_info["theme"]["th_bg"]);
  $phpgw->template->set_var("th_font",$phpgw_info["theme"]["font"]);
  $phpgw->template->set_var("th_text",$phpgw_info["theme"]["th_text"]);

  for ($i=0;$i<count($news);$i++) {
    $nntp->read_table($news[$i]);
    if ($nntp->errorset) {
      echo $nntp->error["msg"].":".$nntp->error["desc"]."<br>\n";
      continue;
    }

    if ($i <> 0 && $i % 3 == 0) {
      $phpgw->template->parse("output","index_table_change_group","True");
    }

    if ($nntp->active == "N") {
      $link_url = lang("x not active",$nntp->groupname);

      $phpgw->template->set_var("groupname",$link_url);		  
    } else {
      $link_url = "<a href=\"".$phpgw->link(
				 $phpgw_info["server"]["webserver_url"]
				."/".$phpgw_info["flags"]["currentapp"]
				."/viewgroup.php","folder=".$news[$i])."\" "
				."target=\"_new\">".$nntp->mailbox."</a>";

      $phpgw->template->set_var("groupname",$link_url);
		  
      $phpgw->template->parse("output","index_table_list_header","True");

      $links = $nntp->get_subjects();
      if (!$links) {
	$phpgw->template->set_var("link_url","");
	$phpgw->template->set_var("description","No articles found!");
	$phpgw->template->parse("output","list","True");
	$phpgw->template->set_var("link_url","");
	$phpgw->template->set_var("description","");
	for($j=1;$j<$nntp->display;$j++)
	  $phpgw->template->parse("output","list","True");
	$phpgw->template->parse("output","index_table_list_footer","True");
	continue;
      }
      krsort($links);
      for ($j=0,reset($links); $j<$nntp->display; $j++,next($links)) {
	$key = key($links);
        $link_url = $phpgw->link(
			 $phpgw_info["server"]["webserver_url"]."/"
			.$phpgw_info["flags"]["currentapp"]."/"
			."read_article.php","folder=".$news[$i]."&msgnum="
			.$key);

	$phpgw->template->set_var("link_url",$link_url);
	$phpgw->template->set_var("description",$links["$key"]);

	$phpgw->template->parse("output","list","True");
      }
      $phpgw->template->parse("output","index_table_list_footer","True");
    }
  }
  $phpgw->template->pparse("out","index_footer");
  $phpgw->common->phpgw_footer();
?>
