<?php
  /**************************************************************************\
  * phpGroupWare - NNTP administration                                       *
  * http://www.phpgroupware.org                                              *
  * Written by Mark Peters <mpeters@satx.rr.com>                             *
  * --------------------------------------------                             *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/

  /* $Id: preferences.php,v 1.23 2001/01/08 03:41:34 skeeter Exp $ */

  $phpgw_info["flags"] = array("noheader" => True, "nonavbar" => True);

  $phpgw_info["flags"]["enable_nextmatchs_class"] = True;
  $phpgw_info["flags"]["currentapp"] = "nntp";
  include("../header.inc.php");

  function get_tg() {
    global $phpgw;

    $phpgw->db->query("SELECT count(con) FROM newsgroups WHERE active='Y'");
    $phpgw->db->next_record();
    return $phpgw->db->f(0);
  }

  if((!isset($submit) || !$submit) && (!isset($nntplist) || !$nntplist)) {
    $urlname = "";

    if (!isset($start) || !$start) $start = 0;

    if (!isset($query_result) || !$query_result) $query_result = 0;

    $orderby = "";
    if (isset($order) && $order) {
      switch ($order) {
        case 1:
          $orderby = " ORDER BY CON $sort";
          break;
        case 2:
          $orderby = " ORDER BY NAME $sort";
          break;
        case 3:
          $orderby = " ORDER BY ACTIVE $sort";
          break;
      }
    } else
      $orderby = "";

    if ((isset($search) && $search) || (isset($next) && $next)) {
      if (isset($search) && $search)
        $query_result = 0;
      else
        $query_result++;
      $phpgw->db->query("SELECT name FROM newsgroups WHERE active='Y'$orderby");
      $j = 0;
      $i = 0;
      while($phpgw->db->next_record()) {
        if (stristr($phpgw->db->f("name"),$query)) {
          if($i==$query_result) {
            $start = $j;
            break;
          } else
            $i++;
        }
        $j++;
      }
    }

    $querystr = "SELECT con, name FROM newsgroups WHERE active='Y'$orderby LIMIT ".$phpgw->nextmatchs->sql_limit($start);
    $phpgw->db->query($querystr);

    if(!$phpgw->db->num_rows()) {
      header("Location: ".$phpgw->link("admin.php"));
    } else {
      $phpgw->common->phpgw_header();
      echo parse_navbar();

      $phpgw->db->query($querystr);
      while($phpgw->db->next_record()) {
	$nntpavailgroups["con"][] = $phpgw->db->f("con");
	$nntpavailgroups["name"][] = $phpgw->db->f("name");
      }
    }

    $phpgw->template->set_file(array( "nntp_header"   => "nntp.tpl",
                        "nntp_list"     => "nntp.tpl",
                        "nntp_footer"   => "nntp.tpl" ));

    $phpgw->template->set_block("nntp_header","nntp_list","nntp_footer");

    if (!isset($tg) || !$tg) {
      $tg = get_tg();
    }

    $first = ($nntpavailgroups["con"])?min($nntpavailgroups["con"]):0;

    $common_hidden_vars = "<input type=\"hidden\" name=\"start\" value=\"".$start."\">\n"
                        . "<input type=\"hidden\" name=\"first\" value=\"".$first."\">\n"
                        . "<input type=\"hidden\" name=\"tg\" value=\"".$tg."\">\n";
    if(isset($order) && $order)
      $common_hidden_vars .= "<input type=\"hidden\" name=\"order\" value=\"".$order."\">\n";
    if(isset($sort) && $sort)
      $common_hidden_vars .= "<input type=\"hidden\" name=\"sort\" value=\"".$sort."\">\n";
    if(isset($query_result) && $query_result)
      $common_hidden_vars .= "<input type=\"hidden\" name=\"query_result\" value=\"".$query_result."\">\n";

    $phpgw->template->set_var("search_value",(isset($query) && $query?$query:""));
    $phpgw->template->set_var("search",lang("search"));
    $phpgw->template->set_var("next",lang("next"));

    $extra_parms = "&tg=".$tg;
    if(isset($sort) && $sort)
      $extra_parms .= "&sort=".$sort;
    if(isset($order) && $order)
      $extra_parms .= "&sort=".$order;

    $phpgw->template->set_var("nml",$phpgw->nextmatchs->left($urlname,
                                        $start,
                                        $tg,
					$extra_parms));
    $phpgw->template->set_var("nmr",$phpgw->nextmatchs->right($urlname,
                                        $start,
                                        $tg,
					$extra_parms));

    $phpgw->template->set_var("title",lang("Newsgroups"));
    $phpgw->template->set_var("action_url",$phpgw->link());
    $phpgw->template->set_var("common_hidden_vars",$common_hidden_vars);
    $phpgw->template->set_var("th_bg",$phpgw_info["theme"]["th_bg"]);
    $phpgw->template->set_var("th_font",$phpgw_info["theme"]["font"]);
    $phpgw->template->set_var("sort_con",$phpgw->nextmatchs->show_sort_order($sort,"1",$order,$urlname," # ","&tg=$tg"));
    $phpgw->template->set_var("sort_group",$phpgw->nextmatchs->show_sort_order($sort,"2",$order,$urlname,"Name","&tg=$tg"));
    $phpgw->template->set_var("sort_active",$phpgw->nextmatchs->show_sort_order($sort,"3",$order,$urlname," Active ","&tg=$tg"));

    $phpgw->template->parse("out","nntp_header");

    if(count($phpgw_info["user"]["preferences"]["nntp"])) {
      while($pref = each($phpgw_info["user"]["preferences"]["nntp"])) {
	$found[$pref[0]] = " checked";
//	echo "Found[".$pref[0]."]<br>\n";
      }
    }

    for($i=0;$i<count($nntpavailgroups["con"]);$i++)
    {
      $tr_color = $phpgw->nextmatchs->alternate_row_color($tr_color);

      $phpgw->template->set_var("tr_color",$tr_color);
      $con = $nntpavailgroups["con"][$i];
      $phpgw->template->set_var("con",$con);

      if (!$nntpavailgroups["name"][$i]) $nntpavailgroups["name"][$i]  = "&nbsp;";
      $phpgw->template->set_var("group",$nntpavailgroups["name"][$i]);

      $active_var = "<input type=\"checkbox\" name=\"nntplist[]\" value=\"$con\"".$found[$con].">";

      $phpgw->template->set_var("active",$active_var);

      if ($i+1 <> count($nntpavailgroups["con"]))
        $phpgw->template->parse("output","nntp_list",True);
    }
    $phpgw->template->set_var("lang_update",lang("update"));
    $phpgw->template->set_var("checkmark",$phpgw_info["server"]["webserver_url"]."/email/images/check.gif");

    $phpgw->template->pparse("out","nntp_footer");
    $phpgw->common->phpgw_footer();
  } else {
    for($i=$start;$i<=$last;$i++) {
      if($phpgw_info["user"]["preferences"]["nntp"][$i]) {
       	$preference = each($phpgw_info["user"]["preferences"]["nntp"]);
        $phpgw->preferences->delete("nntp",$preference[0]);
      }
    }

    for ($i=0;$i<count($nntplist);$i++) {
      $phpgw->preferences->change("nntp",$nntplist[$i],True);
    }
    $phpgw->preferences->commit();

    Header("Location: " . $phpgw->link($urlname,"start=$start&tg=$tg"));
  }
?>
