<?php
  /**************************************************************************\
  * phpGroupWare application (NNTP)                                               *
  * http://www.phpgroupware.org                                              *
  * Written by Mark Peters <mpeters@satx.rr.com>                             *
  * --------------------------------------------                             *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/

  /* $Id: read_article.php,v 1.19 2000/12/24 00:30:41 jengo Exp $ */

  $phpgw_info["flags"] = array("currentapp" => "nntp", "enable_vfs_class" => True);
  include("../header.inc.php");

  include($phpgw_info["server"]["app_inc"]."/message.inc.php");

  function close_routine()
  {
    global $nntp;
    $nntp->close_port();
  }

  @set_time_limit(0);

  $phpgw->translation->add_app("email");

  function compose($action,$icon) {
    global $nntp;
    global $phpgw_info;
    global $phpgw;

    $str = "<a href=\"".$phpgw->link($phpgw_info["server"]["webserver_url"]."/"
		       .$phpgw_info["flags"]["currentapp"]
		       ."/compose.php","action=$action&folder="
		       .$nntp->con."&msgnum=".$nntp->msgnum)."\">";
    $str .= "<img src=\"".$phpgw_info["server"]["app_images"] . "/". $icon
	  . "\" height=\"19\" width=\"26\" alt=\"" . lang($action) 
	  . "\"></a>";

    return $str;
  }

  if (!$phpgw_info["user"]["preferences"]["nntp"]["$folder"]) {
    echo "You do not have access to this newsgroup!<br>\n";
    $phpgw->common->phpgw_exit();
  }

  if(!$folder && !$msgnum) {
    echo lang("Cannot display the requested article from this newsgroup")."<br>\n";
    $phpgw->common->phpgw_exit();
  }

  $nntp = new NNTP($folder,$msgnum);
  if ($nntp->errorset) { echo $nntp->error["msg"].":".$nntp->error["desc"]."<br>\n"; $phpgw->common->phpgw_exit();
 }

  register_shutdown_function("close_routine");

  $phpgw->template->set_file(array( "header"		=> "msg.tpl",
		      "action"		=> "msg_misc_action.tpl",
		      "next_prev"	=> "msg_misc.tpl",
		      "msg_header_label"=> "msg_header_label.tpl",
		      "msg_header_data"	=> "msg_header_data.tpl",
		      "msg_header_footer"=> "msg_header_footer.tpl",
		      "body"		=> "msg.tpl",
		      "attachment"	=> "msg_attach.tpl" ));

  $phpgw->template->set_block("header","action","next_prev","msg_header_label",
		"msg_header_data","msg_header_footer","body","attachment",
		"output_action","output","header_label","header_info");

  $phpgw->template->set_var("th_em_folder",$phpgw_info["theme"]["em_folder"]);
  $phpgw->template->set_var("th_font",$phpgw_info["theme"]["font"]);
  $phpgw->template->set_var("th_em_text",$phpgw_info["theme"]["em_folder_text"]);
  $phpgw->template->set_var("th_bg",$phpgw_info["theme"]["th_bg"]);
  $phpgw->template->set_var("th_row_on",$phpgw_info["theme"]["row_on"]);

  $phpgw->template->set_var("folder_url",$phpgw->link(
				 $phpgw_info["server"]["webserver_url"]."/"
				.$phpgw_info["flags"]["currentapp"]."/"
				."viewgroup.php","folder=".$nntp->con));
  $phpgw->template->set_var("folder",$nntp->folder);

  $phpgw->template->parse("out","header");

  $phpgw->template->set_var("url",compose("reply","sm_reply.gif"));
  $phpgw->template->parse("output_action_bar","action","True");

  $phpgw->template->set_var("url",compose("reply all","sm_reply_all.gif"));
  $phpgw->template->parse("output_action_bar","action","True");

  $phpgw->template->set_var("url",compose("forward","sm_forward.gif"));
  $phpgw->template->parse("output_action_bar","action","True");

  $phpgw->template->set_var("url","<img src=\""
		.$phpgw_info["server"]["app_images"] . "/sm_delete.gif\" "
		."height=\"19\" width=\"26\" alt=\"" . lang("delete")
		."\">");
  $phpgw->template->parse("output_action_bar","action","True");

  $np_msg = "<a href=\"".$phpgw->link(
				 $phpgw_info["server"]["webserver_url"]."/"
				.$phpgw_info["flags"]["currentapp"]
				."/read_article.php","folder=".$nntp->con);

  $pm = $nntp->get_prev_article_number($nntp->msgnum);
  if ((int)$pm <> 0)
    $str = $np_msg."&msgnum=".(int)$pm . "\"><img border=\"0\" src=\""
	 . $phpgw_info["server"]["images_dir"]."/left.gif\" alt=\""
	 . lang("Previous")."\"></a>";
  else
    $str = "<img border=0 src=\"".$phpgw_info["server"]["images_dir"]
	 . "/left-grey.gif\" alt=\"".lang("Previous")."\">";

  $phpgw->template->set_var("pm",$str);

  $nm = $nntp->get_next_article_number($nntp->msgnum);
  if ((int)$nm <> 0)
    $str = $np_msg."&msgnum=".(int)$nm . "\"><img border=\"0\" src=\""
	 . $phpgw_info["server"]["images_dir"]."/right.gif\" alt=\""
	 . lang("Next")."\"></a>";
  else
    $str = "<img border=0 src=\"".$phpgw_info["server"]["images_dir"]
	 . "/right-grey.gif\" alt=\"".lang("Next")."\">";

  $phpgw->template->set_var("nm",$str);

  $phpgw->template->parse("output_action_bar","next_prev","True");

  $phpgw->template->set_var("label",lang("from"));
  $phpgw->template->parse("output","msg_header_label","True");
  $from = $nntp->msg->from[0];

  $phpgw->template->set_var("header_title",send_to($from,$nntp->con));
  $phpgw->template->set_var("header_icon",add_to_addressbook($from));
  $phpgw->template->parse("output","msg_header_data","True");
  $phpgw->template->parse("output","msg_header_footer","True");


  $phpgw->template->set_var("label",lang("to"));
  $phpgw->template->parse("output","msg_header_label","True");
  $to = new address;
  for($i=0;$i<count($nntp->msg->to);$i++) {
    if (!$nntp->msg->to[$i]) break;
    $to = $nntp->msg->to[$i];
    $topersonal = $to->personal;
    $nntp->db->query("SELECT con FROM newsgroups WHERE name='" 
		   . $topersonal . "' and active='Y'");

    if ($nntp->db->num_rows() > 0) {
      $nntp->db->next_record();
      $con = $nntp->db->f("con");
      $phpgw->template->set_var("header_title",send_to($to,$nntp->con));
      if (!$phpgw_info["user"]["preferences"]["nntp"]["$con"]) {
	$monitor = monitor(1,$con);
      } else {
	$monitor = monitor(0,0);
      }
    } else {
      $toadl = $to->adl;
      $phpgw->template->set_var("header_title",$toadl);
      $monitor = monitor(0,0);
    }
    if($i<count($nntp->msg->to)) $monitor .= "<br>";
    $phpgw->template->set_var("header_icon",$monitor);
    $phpgw->template->parse("output","msg_header_data","True");
  }
  $phpgw->template->parse("output","msg_header_footer","True");


  if (isset($nntp->header["Cc"]) && $nntp->header["Cc"]) {
    $phpgw->template->set_var("label",lang("cc"));
    $phpgw->template->parse("output","msg_header_label","True");
    for($I=0;$i<count($nntp->msg->cc);$i++) {
      $phpgw->template->set_var("header_title",send_to($nntp->msg->cc[$i],$nntp->con));
      $phpgw->template->set_var("header_icon",add_to_addressbook($nntp->msg->cc[$i]));  
      $phpgw->template->parse("output","msg_header_data","True");
    }
    $phpgw->template->parse("output","msg_header_footer","True");
  }

  $phpgw->template->set_var("label",lang("date"));
  $phpgw->template->parse("output","msg_header_label","True");
  $phpgw->template->set_var("header_title",$phpgw->common->show_date($nntp->msg->udate));
  $phpgw->template->set_var("header_icon","");
  $phpgw->template->parse("output","msg_header_data","True");
  $phpgw->template->parse("output","msg_header_footer","True");

// Still doing nothing with attachments

  $phpgw->template->set_var("label",lang("subject"));
  $phpgw->template->parse("output","msg_header_label","True");
  $phpgw->template->set_var("header_title",$nntp->msg->subject);
  $phpgw->template->set_var("header_icon","");
  $phpgw->template->parse("output","msg_header_data","True");
  $phpgw->template->parse("output","msg_header_footer","True");

  $phpgw->template->set_var("textbody",$nntp->build_body_to_print());
  $phpgw->template->pparse("out","body");

  $phpgw->common->phpgw_footer();
?>
