<?php
  /**************************************************************************\
  * phpGroupWare application (NNTP)                                               *
  * http://www.phpgroupware.org                                              *
  * Written by Mark Peters <mpeters@satx.rr.com>                             *
  * --------------------------------------------                             *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/

  /* $Id: viewgroup.php,v 1.17 2000/12/24 00:30:41 jengo Exp $ */

  $phpgw_info["flags"]["enable_nextmatchs_class"] = True;
  $phpgw_info["flags"]["currentapp"] = "nntp";
  include("../header.inc.php");

  function close_routine()
  {
    global $nntp;
    $nntp->close_port();
  }

  @set_time_limit(0);

  $phpgw->translation->add_app("email");

  $phpgw->db->query("SELECT active FROM newsgroups WHERE con=$folder AND active='Y'");
  if (($phpgw->db->num_rows() == 0) || !$phpgw_info["user"]["preferences"]["nntp"]["$folder"] ) {
    echo "You do not have access to this newsgroup!<br>\n";
    $phpgw->common->phpgw_exit();
  }

  if(!$folder) {
    echo lang("Cannot display the requested newsgroup")."<br>\n";
    $phpgw->common->phpgw_exit();
  }

  $nntp = new NNTP($folder);
  $nntp->display = $phpgw_info["user"]["preferences"]["common"]["maxmatchs"];
  if ($nntp->errorset) {
    echo $nntp->error["msg"].":".$nntp->error["desc"]."<br>\n";
    $phpgw->common->phpgw_exit();
  }
 
  register_shutdown_function("close_routine");

  $phpgw->template->set_file(array( "vg_header"		=> "view_group.tpl",
		      "vg_table_header"		=> "view_group.tpl",
		      "vg_list"			=> "view_group.tpl",
		      "vg_table_footer"		=> "view_group.tpl",
		      "vg_footer"		=> "view_group.tpl" ));

  $phpgw->template->set_block("vg_header","vg_table_header","vg_list","vg_table_footer",
		"vg_footer","output");

  $nntp->read_table($folder);

  $phpgw->template->set_var("th_bg",$phpgw_info["theme"]["th_bg"]);
  $phpgw->template->set_var("th_font",$phpgw_info["theme"]["font"]);
  $phpgw->template->set_var("th_text",$phpgw_info["theme"]["th_text"]);
  $phpgw->template->set_var("th_em_folder",$phpgw_info["theme"]["em_folder"]);
  $phpgw->template->set_var("th_em_text",$phpgw_info["theme"]["em_folder_text"]);

  $phpgw->template->set_var("folder",$nntp->folder);

  if (!$start) $start = 0;

  if (!$tm) $tm = ($nntp->highmsg - $nntp->lowmsg);
  if (!$fm) $fm = $nntp->lowmsg;

  $phpgw->template->set_var("nml",$phpgw->nextmatchs->left("viewgroup.php",$start,$tm,
				      "&folder=$folder&tm=$tm&fm=".$fm));

  $phpgw->template->set_var("nmr",$phpgw->nextmatchs->right("viewgroup.php",$start,$tm,
				      "&folder=$folder&tm=$tm&fm=".$fm));
  $phpgw->template->parse("out","vg_header");

  $phpgw->template->set_var("row_color",$phpgw_info["theme"]["th_bg"]);
  $phpgw->template->set_var("from","<font size=\"2\"><b>".lang("from")."</b></font>");
  $phpgw->template->set_var("subject","<font size=\"2\"><b>".lang("subject")."</b></font>");
  $phpgw->template->set_var("date","<font size=\"2\"><b>".lang("date")."</b></font>");
//  $phpgw->template->set_var("size","<font size=\"2\"><b>".lang("size")."</b></font>");

  $phpgw->template->parse("output","vg_table_header","True");

  if ($phpgw_info["user"]["preferences"]["common"]["maxmatchs"] <= ($tm - $start))
    $totaltodisplay = $phpgw_info["user"]["preferences"]["common"]["maxmatchs"];
  else
    $totaltodisplay = ($tm - $start);

  $firstmessage = ($fm + $start);
  $list = $nntp->get_list("from",$firstmessage,$totaltodisplay);
//  $subject = $nntp->get_list("subject",$firstmessage,$firstmessage+$totaltodisplay);
//  $date = $nntp->get_list("date",$firstmessage,$firstmessage+$totaltodisplay);

  for ($i=0;$i<$totaltodisplay;$i++) {
    $tr_color = $phpgw->nextmatchs->alternate_row_color($tr_color);
    $phpgw->template->set_var("row_color",$tr_color);

    $phpgw->template->set_var("from","<font size=\"-1\">".$list[$i]["From"]."</font>");

    $subject_url = $phpgw->link("read_article.php",
				"folder=".$nntp->con."&msgnum=".$list[$i]["Msgnum"]);
    $subject_field = "<font size=\"-1\"><a href=\"".$subject_url."\">"
		   . $list[$i]["Subject"]."</a></font>";
    $phpgw->template->set_var("subject",$subject_field);
					       
    $phpgw->template->set_var("date",
	"<font size=\"-2\">".$phpgw->common->show_date($list[$i]["Date"])."</font>");
//    $phpgw->template->set_var("size","");

    if ($i < ($start+$totaltodisplay-1))
      $phpgw->template->parse("output","vg_table_header","True");

  }        
  $phpgw->template->pparse("out","vg_footer");
  $phpgw->common->phpgw_footer();
?>
